
package dk.myrekrig;

import java.util.*;

class Statistics {

    Team[] teams;

    Stat[] total;
    Stat[] totalsq;
    Stat[] win;

    float[][] paramstat;
    float[][] teamstat;

    public Statistics(Game game) {
	teams = (Team[])game.teams.clone();

	total   = new Stat[teams.length];
	totalsq = new Stat[teams.length];
	win     = new Stat[teams.length];

	for (int i = 0 ; i < teams.length ; i++) {
	    total[i]   = new Stat(teams.length);
	    totalsq[i] = new Stat(teams.length);
	    win[i]     = new Stat(teams.length);
	}


	Stat s = new Stat(teams.length);
	for (int i = 0 ; i < game.battles.length ; i++) {
	    // Make Stat
	    Battle b = game.battles[i];
	    s.mapsize = b.used.mapwidth * b.used.mapheight;
	    s.startants = b.used.startants;
	    s.nfspace = b.used.nfspace;
	    s.nfsize = b.used.nfmin*2+b.used.nfdiff;
	    s.battlesize = b.used.battlesize;
	    Arrays.fill(s.teams, 0);
	    for (int j = 0 ; j < b.teams.length ; j++) {
		s.teams[b.teams[j].letter-'A'] = 1;
	    }
	    s.turns = b.turns;

	    // Add to the relevant sums
	    win[b.winner.letter-'A'].add(s);
	    for (int j = 0 ; j < b.teams.length ; j++) {
		total[b.teams[j].letter-'A'].add(s);
	    }
	    s.mul(s);
	    for (int j = 0 ; j < b.teams.length ; j++) {
		totalsq[b.teams[j].letter-'A'].add(s);
	    }
	}

	paramstat = new float[teams.length][6];
	teamstat = new float[teams.length][teams.length];

	for (int i = 0 ; i < teams.length ; i++) {
	    long[] total_a = { total[i].mapsize, total[i].startants, total[i].nfspace, total[i].nfsize, total[i].battlesize, total[i].turns };
	    long[] totalsq_a = { totalsq[i].mapsize, totalsq[i].startants, totalsq[i].nfspace, totalsq[i].nfsize, totalsq[i].battlesize, totalsq[i].turns };
	    long[] win_a = { win[i].mapsize, win[i].startants, win[i].nfspace, win[i].nfsize, win[i].battlesize, win[i].turns };
	    for (int j = 0 ; j < 6 ; j++) {
		int n   = teams[i].battles;
		int w   = teams[i].won;
		long e  = n*win_a[j]-w*total_a[j];
		long d1 = n*w-w*w;
		long d2 = n*totalsq_a[j]-total_a[j]*total_a[j];

		paramstat[i][j] = (float)(((double)e)/Math.sqrt(((double)d1)*((double)d2)));
	    }
	}

	for (int i = 0 ; i < teams.length ; i++) {
	    long[] total_a = total[i].teams;
	    long[] totalsq_a = totalsq[i].teams;
	    long[] win_a = win[i].teams;
	    for (int j = 0 ; j < teams.length ; j++) {
		int n   = teams[i].battles;
		int w   = teams[i].won;
		long e  = n*win_a[j]-w*total_a[j];
		long d1 = n*w-w*w;
		long d2 = n*totalsq_a[j]-total_a[j]*total_a[j];

		teamstat[i][j] = (float)(((double)e)/Math.sqrt(((double)d1)*((double)d2)));
	    }
	}
	
    }
}
