
package dk.myrekrig;

import java.util.*;

class TeamComparator implements Comparator {
    private int sort;

    public TeamComparator(int sort) {
	this.sort = sort;
    }

    public int compare(Object o1, Object o2) {
	Team t1 = (Team)o1;
	Team t2 = (Team)o2;
	switch (sort) {
	case MyreKrig.RES_RACE:
	    return t1.race.title.compareToIgnoreCase(t2.race.title);
	case MyreKrig.RES_MEM:
	    return t1.mem_size-t2.mem_size;
	case MyreKrig.RES_BASES:
	    return compareFloats(t2.bases, t1.bases);
	case MyreKrig.RES_ANTS:
	    return t2.ants-t1.ants;
	case MyreKrig.RES_COMB:
	    return compareFloats(t2.comb, t1.comb);
	case MyreKrig.RES_TIME:
	    return compareFloats(t1.time, t2.time);
	case MyreKrig.RES_VICT:
	    return compareFloats(t2.vict, t1.vict);
	case MyreKrig.RES_PERF:
	    return compareFloats(t2.perf, t1.perf);
	case MyreKrig.RES_PRES:
	    return compareFloats(t2.pres, t1.pres);
	case MyreKrig.RES_OVER:
	    return compareFloats(t2.over, t1.over);
	default:
	    return 0;
	}
    }

    private int compareFloats(float a, float b) {
	return (a < b ? -1 : a > b ? 1 : 0);
    }
}
