import java.lang.*;
import java.util.*;
import java.lang.Thread;
import java.lang.reflect.Method;

/**
 * This is an example implementation of the advice
 * for Synchronization aspect of the GET method.
 * Every advice must implement AdviceIF.
 */
public class Adv_SyncGet implements AdviceIF {
  public int beforeAdvice(Object obj, Method m, Object[] args) {
    BoundedBuffer bb = (BoundedBuffer) obj;
    if (bb.getCnt() > 0 ) {
      // System.out.println(t + " gets dispatched.");
      return AspectRepository.RESUME;
    } else {
      // System.out.println(t + " gets blocked.");
      return AspectRepository.BLOCK;
    }
  }

  public Object afterAdvice(Object obj, Method m, Object[] args, Object result) {
    return null;
  }

  public String getAspectName() { return "SYNC"; }
}
