import java.io.File;
import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.event.*;

/**
 * Title:        Producer Consumer - Dynamic Weaver Framework
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

/**
 * Configures the system before the start button is pressed.
 * Sets
 * - number of put threads
 * - number of get threads
 * - size of the buffer
 */

public class ConfigDialog extends JDialog {
  // The default directory to display in the FileDialog
  File currDir = new File(System.getProperty("user.dir"));

  JPanel panel1 = new JPanel();
  JPanel jPanel1 = new JPanel();
  Border border1;
  JPanel jPanel2 = new JPanel();
  Border border2;
  JPanel jPanel3 = new JPanel();
  Border border3;
  JButton btnOK = new JButton();
  JButton btnSetDefault = new JButton();
  JButton btnCancel = new JButton();
  FlowLayout flowLayout1 = new FlowLayout();
  JLabel jLabel1 = new JLabel();
  JLabel jLabel2 = new JLabel();
  JLabel jLabel3 = new JLabel();
  JTextField txtBufSize = new JTextField();
  JTextField txtProdCnt = new JTextField();
  JTextField txtConsCnt = new JTextField();
  BorderLayout borderLayout1 = new BorderLayout();
  BorderLayout borderLayout2 = new BorderLayout();
  JLabel jLabel4 = new JLabel();
  JTextField txtPolicyInputFileName = new JTextField();
  JButton btnFileBrowse = new JButton();
  GridBagLayout gridBagLayout1 = new GridBagLayout();

  public ConfigDialog(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    try {
      jbInit();
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public ConfigDialog() {
    this(null, "", false);
  }
  void jbInit() throws Exception {
    border1 = BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142));
    border2 = BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142));
    border3 = BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142));
    panel1.setLayout(borderLayout1);
    this.getContentPane().setLayout(borderLayout2);
    jPanel1.setBorder(border1);
    jPanel2.setBorder(border2);
    jPanel2.setLayout(gridBagLayout1);
    jPanel3.setBorder(border3);
    jPanel3.setMinimumSize(new Dimension(500, 41));
    jPanel3.setPreferredSize(new Dimension(500, 41));
    jPanel3.setLayout(flowLayout1);
    btnOK.setText("OK");
    btnOK.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnOK_actionPerformed(e);
      }
    });
    btnSetDefault.setText("Default Values");
    btnSetDefault.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnSetDefault_actionPerformed(e);
      }
    });
    btnCancel.setText("Cancel");
    btnCancel.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnCancel_actionPerformed(e);
      }
    });
    jLabel1.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabel1.setText("Buffer Size");
    jLabel2.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabel2.setText("Number of Producer Threads");
    jLabel3.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabel3.setText("Number of Consumer Threads");
    txtBufSize.setMinimumSize(new Dimension(50, 21));
    txtBufSize.setPreferredSize(new Dimension(50, 21));
    txtBufSize.setText("65");
    txtProdCnt.setMinimumSize(new Dimension(50, 21));
    txtProdCnt.setPreferredSize(new Dimension(50, 21));
    txtProdCnt.setText("65");
    txtConsCnt.setMinimumSize(new Dimension(50, 21));
    txtConsCnt.setPreferredSize(new Dimension(50, 21));
    txtConsCnt.setText("65");
    txtPolicyInputFileName.setText("PolicyTraining.txt");
    this.setResizable(false);
    this.setTitle("Set Configuration");
    jLabel4.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabel4.setText("Policy Data input File");
    btnFileBrowse.setText("...");
    btnFileBrowse.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnFileBrowse_actionPerformed(e);
      }
    });
    getContentPane().add(panel1, BorderLayout.CENTER);
    panel1.add(jPanel2, BorderLayout.CENTER);
    jPanel2.add(txtBufSize,   new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(75, 0, 6, 13), 0, 3));
    jPanel2.add(txtProdCnt,   new GridBagConstraints(1, 1, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 6, 13), 0, 3));
    jPanel2.add(txtConsCnt,   new GridBagConstraints(1, 2, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 6, 13), 0, 3));
    jPanel2.add(jLabel1,  new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(75, 11, 0, 0), 116, 13));
    jPanel2.add(jLabel2,  new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 11, 0, 0), 13, 13));
    jPanel2.add(jLabel3,  new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 11, 0, 0), 7, 13));
    jPanel2.add(jLabel4,  new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 19, 0, 0), 50, 4));
    jPanel2.add(txtPolicyInputFileName,  new GridBagConstraints(1, 3, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 13), 192, 0));
    jPanel2.add(btnFileBrowse,    new GridBagConstraints(1, 4, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(1, 3, 28, 162), -1, -8));
    panel1.add(jPanel3, BorderLayout.SOUTH);
    jPanel3.add(btnOK, null);
    jPanel3.add(btnSetDefault, null);
    jPanel3.add(btnCancel, null);
    panel1.add(jPanel1, BorderLayout.NORTH);
  }

  void btnSetDefault_actionPerformed(ActionEvent e) {
    txtBufSize.setText("65");
    txtProdCnt.setText("65");
    txtConsCnt.setText("65");
    txtPolicyInputFileName.setText("PolicyTraining.txt");
  }

  void btnCancel_actionPerformed(ActionEvent e) {
    this.hide();
  }

  void btnOK_actionPerformed(ActionEvent e) {
    try {
      ProdConsApp.setMyBufferSize(Integer.parseInt(txtBufSize.getText()));
      ProdConsApp.setMyProducerCnt(Integer.parseInt(txtProdCnt.getText()));
      ProdConsApp.setMyConsumerCnt(Integer.parseInt(txtConsCnt.getText()));
      ProdConsApp.setMyInputFileName(txtPolicyInputFileName.getText());
    }
    catch (NumberFormatException ex) {
        JOptionPane.showMessageDialog(this,
            "Failed to configure the system\n" +
            "Error: " + ex.getLocalizedMessage());
    }
    this.hide();
  }

  void btnFileBrowse_actionPerformed(ActionEvent e) {
    // Create a file dialog box for a new file to write data into.
    JFileChooser  fc = new JFileChooser ();
    fc.setDialogTitle("DWF - Policy Data Input File Selection");
    fc.setCurrentDirectory(currDir);

    // Display the dialog and wait for the user's response
    int returnVal = fc.showOpenDialog(this);
    // Remember new default direcotry
    currDir = fc.getCurrentDirectory();

    if (returnVal != JFileChooser.APPROVE_OPTION) return;

    String myFileName = fc.getSelectedFile().getAbsolutePath();

    try {
      txtPolicyInputFileName.setText(myFileName);
    } catch (Exception ex) {
        JOptionPane.showMessageDialog(this,
            "Failed to select input data file " + myFileName + "\n" +
            "Error: " + ex.getLocalizedMessage());
        //ex.printStackTrace();
      return;
    }
  }
}
