import java.lang.Thread;
/**
 * A number of comsumer threads will be created for the demonstration of the
 * DWF for the bounded buffer.
 * A number of producer threads will be created for the demonstration of the
 * DWF for the bounded buffer.
 *
 */
public class MyDemo extends Thread {
  private BoundedBufferIF myBuf = ProdConsApp.getMyBufferProxy();
  static int maxProducer = ProdConsApp.getMyProducerCnt();
  static int maxConsumer = ProdConsApp.getMyConsumerCnt();
  static private boolean paused = false;
  static private boolean stopped = true;
  static private MyProducer[] prod = null; // new MyProducer[maxProducer];
  static private MyConsumer[] cons = null; // new MyConsumer[maxConsumer];

  MyDemo() {
    maxProducer = ProdConsApp.getMyProducerCnt();
    maxConsumer = ProdConsApp.getMyConsumerCnt();
    prod = new MyProducer[maxProducer];
    cons = new MyConsumer[maxConsumer];
  }

  public void run() {
    int i;

    for (i = 0; i < maxProducer; i++) {
      prod[i] = new MyProducer (myBuf);
      prod[i].setName("producer " + i);
      prod[i].set_seed(i);
    }

    for (i = 0; i < maxConsumer; i++) {
      cons[i] = new MyConsumer (myBuf);
      cons[i].setName("consumer " + i);
      cons[i].set_seed(i + maxProducer);
    }

    for (i = 0; i < maxProducer; i++) { prod[i].start();}
    for (i = 0; i < maxConsumer; i++) { cons[i].start();}

    /*
    for (int i = 0; i < max_threads; i++) {
        try {
            cons[i].join();
            prod[i].join();
        } catch (InterruptedException ex) { }
    }
    */
  }

  public static void setPaused(boolean b) { paused = b; }

  public static void setStopped(boolean b) {
    stopped = b;
    if (stopped) {
      int i;

      for (i = 0; i < maxProducer; i++) {
        try { prod[i].join();}
        catch (InterruptedException ex) { }
      }
      for (i = 0; i < maxConsumer; i++) {
        try { cons[i].join();}
        catch (InterruptedException ex) { }
      }
    }
  }

  public static boolean getPaused() { return paused; }
  public static boolean getStopped() { return stopped; }
}

