import java.io.File;
import java.util.Vector;
import java.util.Enumeration;
import java.lang.reflect.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.event.*;

/**
 * Title:        Producer Consumer - Dynamic Weaver Framework
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

/**
 * Shows the available policy on the screen.
 * User can add and remove scheduling policies.
 * User can select current policy.
 */
public class PolicyDialog extends JDialog {
  JPanel panel1 = new JPanel();
  JPanel jPanel1 = new JPanel();
  JPanel jPanel2 = new JPanel();
  JPanel jPanel3 = new JPanel();
  JButton btnAddPolicy = new JButton();
  JButton btnRemovePolicy = new JButton();
  JButton btnSetCurrentPolicy = new JButton();
  JButton btnClose = new JButton();
  JList policyList = new JList();
  JLabel jLabel1 = new JLabel();
  JLabel jLabel2 = new JLabel();
  JLabel currPolicyName = new JLabel();
  Border border1;

  // The default directory to display in the FileDialog
  File currDir = new File(System.getProperty("user.dir"));
  JScrollPane jScrollPane1 = new JScrollPane();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  GridBagLayout gridBagLayout2 = new GridBagLayout();
  BorderLayout borderLayout1 = new BorderLayout();

  public PolicyDialog(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    try {
      jbInit();
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public PolicyDialog() {
    this(null, "", false);
  }
  void jbInit() throws Exception {
    border1 = BorderFactory.createBevelBorder(BevelBorder.LOWERED,Color.white,Color.white,new Color(142, 142, 142),new Color(99, 99, 99));
    panel1.setLayout(borderLayout1);
    jPanel1.setBorder(BorderFactory.createEtchedBorder());
    jPanel1.setLayout(null);
    jPanel2.setBorder(BorderFactory.createEtchedBorder());
    jPanel2.setLayout(gridBagLayout1);
    jPanel3.setBorder(BorderFactory.createEtchedBorder());
    jPanel3.setLayout(gridBagLayout2);
    btnAddPolicy.setText("Add");
    btnAddPolicy.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnAddPolicy_actionPerformed(e);
      }
    });
    btnRemovePolicy.setText("Remove");
    btnRemovePolicy.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnRemovePolicy_actionPerformed(e);
      }
    });
    btnSetCurrentPolicy.setText("Set Current");
    btnSetCurrentPolicy.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnSetCurrentPolicy_actionPerformed(e);
      }
    });
    btnClose.setText("Close");
    btnClose.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnClose_actionPerformed(e);
      }
    });
    policyList.setBorder(BorderFactory.createLoweredBevelBorder());
    jLabel1.setText("Registered Policies");
    jLabel2.setText("Current Policy");
    currPolicyName.setBorder(border1);
    currPolicyName.setText(" ");
    this.setResizable(false);
    this.setTitle("Policies");
    jScrollPane1.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
    getContentPane().add(panel1);
    panel1.add(jPanel1, BorderLayout.NORTH);
    panel1.add(jPanel2, BorderLayout.CENTER);
    jPanel2.add(jScrollPane1,  new GridBagConstraints(0, 3, 1, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 6, 15, 9), -63, -59));
    jScrollPane1.getViewport().add(policyList, null);
    jPanel2.add(jLabel1,  new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 6, 0, 19), 95, 2));
    jPanel2.add(jLabel2,  new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(1, 6, 0, 137), 9, 1));
    jPanel2.add(currPolicyName,  new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 6, 0, 9), 206, 4));
    panel1.add(jPanel3, BorderLayout.SOUTH);
    jPanel3.add(btnRemovePolicy, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 14, 0, 13), 16, 0));
    jPanel3.add(btnAddPolicy,  new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 7, 0, 0), 42, 0));
    jPanel3.add(btnSetCurrentPolicy,  new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 7, 5, 0), 0, 0));
    jPanel3.add(btnClose,  new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 14, 5, 13), 30, 0));
  }


  public void show() {


    AspectRepository ar = ProdConsApp.getAspectRepository();
    policyList.setListData(ar.getAllPolicyInfo());
    currPolicyName.setText(ar.getCurrPolicyName());

    super.show();
  }

  void btnAddPolicy_actionPerformed(ActionEvent e) {
    // Create a file dialog box to prompt for a new file to load.
    JFileChooser  fc = new JFileChooser ();
    fc.setDialogTitle("DWF - Policy Loader");
    fc.setCurrentDirectory(currDir);

    // Display the dialog and wait for the user's response
    int returnVal = fc.showOpenDialog(this);

    // Remember new default direcotry
    currDir = fc.getCurrentDirectory();

    if (returnVal != JFileChooser.APPROVE_OPTION) return;

    String myFileName = fc.getSelectedFile().getName();
    int idx = myFileName.indexOf(".class", 0);
    if (idx < 0) {
      JOptionPane.showMessageDialog(this, myFileName + " is not a class file.");
      return;
    }

    String myClassName = "" + myFileName.substring(0, idx);  //  without extension
    AspectRepository ar = ProdConsApp.getAspectRepository();
    try {
        Class myClass = Class.forName(myClassName);
        Preference myNewPolicy = (Preference) myClass.newInstance();
        //
        //String policyName = myNewPolicy.getPolicyName();

        if (ar.getAllPolicyInfo().contains(myClassName))
          JOptionPane.showMessageDialog(this,
            "already registered policy: " + myClassName);
        else {
          ar.addPolicy(myClassName);
          policyList.setListData(ar.getAllPolicyInfo());
          //JOptionPane.showMessageDialog(this,
          //  "Successfully added a new policy: " + myClassName);
        }
    } catch (Exception ex) {
        JOptionPane.showMessageDialog(this,
            "Failed to add a new policy " + myClassName + "\n" +
            "Error: " + ex.getLocalizedMessage());
        //ex.printStackTrace();
      return;
    }
  }

  void btnClose_actionPerformed(ActionEvent e) {
    this.hide();
  }


  void btnRemovePolicy_actionPerformed(ActionEvent e) {
    if (policyList.getModel().getSize() == 0) {
      JOptionPane.showMessageDialog(this, "No items in the list.");
      return;
    }
    if (policyList.isSelectionEmpty()) {
      JOptionPane.showMessageDialog(this, "First select policies to be removed.");
      return;
    }

    // remove all the selected policies
    Object [] policies = policyList.getSelectedValues();
    AspectRepository ar = ProdConsApp.getAspectRepository();

    for (int i = 0; i < policies.length; i++) {
       ar.removePolicy((String) policies[i]);
    }
    show();
  }

  void btnSetCurrentPolicy_actionPerformed(ActionEvent e) {
    if (policyList.getModel().getSize() == 0) {
      JOptionPane.showMessageDialog(this, "No items in the list.");
      return;
    }
    if (policyList.isSelectionEmpty()) {
      JOptionPane.showMessageDialog(this, "First select a policy.");
      return;
    }

    Object [] policies = policyList.getSelectedValues();
    if (policies.length > 1) {
      JOptionPane.showMessageDialog(this, "Select only one policy.");
      return;
    }

    AspectRepository ar = ProdConsApp.getAspectRepository();
    ar.changePolicy( (String) policies[0] );
    show();
  }
}
